Subject: Re: memcpy regression

From: Michael Ellerman <[email-masked]>
Date: Mon, 07 Sep 2015 11:14:10 +1000

Hi Michal,

Thanks for finding the problem.

On Sun, 2015-09-06 at 23:01 +0200, Michal Sojka wrote:
> 
> I found the problem. The compiler replaces an assignment with a call to
> memcpy. The following patch fixes the problem for me. However, I'm not
> sure whether this is the real solution. I guess the compiler is free to
> generate a call to memcpy wherever it wants so other compilers or other
> optimization levels may need fixes at other places. What do others
> think?

I think you're right that it's not a good solution, the compiler could generate
other calls to memcpy depending on various factors, and people will add new
code that causes memcpy to get called and it will break your platform.

Christophe, am I right that the problem here is that your new memcpy() doesn't
work until later in boot when caches are enabled?

cheers